\documentclass[noanswers, nolegalese, 11pt]{examjh}
% \documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for One.3, One.4\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}


\begin{questions}
\question
\begin{parts}
\part 
State Church's Thesis.
\part
Why is it a thesis and not a theorem?
\part
What does it mean to consider it as an empirical matter?
\end{parts}
\begin{solution}
\begin{parts}
\part
The set of things that can be computed by a discrete and
deterministic mechanism is the same as the set of things that can be computed by
a Turing machine.
\part
When you are setting up a mathematical model, in this case for the 
model of mechanical computation, you need a first step.
In this field, that first step is provided by the definition of Turing machine.
We have provided justification for that, but in the end it is persuasive
argument, rather than logical necessity.
\item
If tomorrow an experiment should appear that shows how to
physically compute something
that is not computable by a Turing machine, then we would switch the 
definition.
\end{parts}
\end{solution}


\question
Name three strengths of Turing's model of computation.
Name three weaknesses.
\begin{solution}
Three strengths are: clarity, 
historical significance, 
and it is the standard model in complexity theory.
Three weaknesses are: difficulty in programming,
need to represent the inputs and outputs,
and that it does not match well with current physical devices. 
\end{solution}


\question
Everyone knows the factorial function.
\begin{center}
\begin{tabular}{r|*{7}{c}}
  \textit{$n$}
    &$0$ &$1$ &$2$ &$3$ &$4$ &$5$ &\ldots{} \\ 
  \cline{2-8}
  \textit{factorial of $n$}
    &$1$ &$1$ &$2$ &$6$ &$24$ &$120$ &\ldots{}
\end{tabular}
\end{center}
Define it using the schema of primitive recursion,
assuming that already defined are the product function and a constant function.
\begin{solution}
The derivation for factorial is this.
\begin{equation*}
  \factorial(y)=\begin{cases}
              1                  &\text{if $y=0$}  \\
              \product(\factorial(z),\successor(z))) &\text{if $y=\successor(z)$}
            \end{cases}
\end{equation*}
Here $g$ is a function of no inputs~$g(\,)=1$ and 
$h(a,b)=\product(a,\successor(b))$.  
\end{solution}


\question
This is the hyperoperation 
$\map{\hyperoperation}{\N^3}{\N}$.
\begin{equation*}
  \hyperoperation(n,x,y)=
  \begin{cases}
    y+1  &\case{if $n=0$}             \\
    x    &\case{if $n=1$ and $y=0$}   \\
    0    &\case{if $n=2$ and $y=0$}   \\
    1    &\case{if $n>2$ and $y=0$}   \\
    \hyperoperation(n-1, x, \hyperoperation(n, x, y-1)) &\case{otherwise}
  \end{cases}
\end{equation*}
We want to argue that it is intuitively mechanically computable.
\begin{parts}
\part
Compute $\hyperoperation(0,3,4)$.
\part
Compute $\hyperoperation(1,3,4)$.
\end{parts}


\end{questions}
\end{document}
